Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 3291)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -369,4 +372,8 @@
                ref_state, rho_ocean, s, s_p, sa_p, tend, u, u_p, v, vpt,       &
                v_p, w, w_p
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY: bulk_cloud_model, calc_liquid_water_content,                     &
+              collision_turbulence, microphysics_morrison, microphysics_seifert
 
     USE calc_mean_profile_mod,                                                 &
@@ -399,5 +406,5 @@
                multi_agent_system_end, multi_agent_system_start,               &
                nesting_offline, neutral, nr_timesteps_this_run, nudging,       &
-               ocean, passive_scalar, prho_reference, pt_reference,            &
+               ocean_mode, passive_scalar, pt_reference,                       &
                pt_slope_offset, random_heatflux, rans_mode,                    &
                rans_tke_e, run_coupled, simulated_time, simulated_time_chr,    &
@@ -443,8 +450,4 @@
                lsf_nesting_offline, lsf_nesting_offline_mass_conservation
 
-    USE bulk_cloud_model_mod,                                                  &
-        ONLY: bulk_cloud_model, calc_liquid_water_content,                     &
-              collision_turbulence, microphysics_morrison, microphysics_seifert
-
     USE netcdf_data_input_mod,                                                 &
         ONLY:  nest_offl, netcdf_data_input_lsf
@@ -452,4 +455,7 @@
     USE multi_agent_system_mod,                                                &
         ONLY:  agents_active, multi_agent_system
+
+    USE ocean_mod,                                                             &
+        ONLY:  prho_reference
 
     USE particle_attributes,                                                   &
@@ -662,5 +668,5 @@
                 ref_state(:)  = hom(:,1,4,0) ! this is used in the buoyancy term
              ENDIF
-             IF ( ocean )  THEN
+             IF ( ocean_mode )  THEN
                 CALL calc_mean_profile( rho_ocean, 64 )
                 ref_state(:)  = hom(:,1,64,0)
@@ -753,5 +759,5 @@
              ENDIF
           ENDIF
-          IF ( ocean )  THEN
+          IF ( ocean_mode )  THEN
              CALL exchange_horiz( sa_p, nbgp )
              CALL exchange_horiz( rho_ocean, nbgp )
@@ -1053,5 +1059,5 @@
              CALL cpu_log( log_point(17), 'diffusivities', 'start' )
              IF ( .NOT. humidity ) THEN
-                IF ( ocean )  THEN
+                IF ( ocean_mode )  THEN
                    CALL tcm_diffusivities( prho, prho_reference )
                 ELSE
Index: palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3291)
+++ palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -164,6 +167,6 @@
                initializing_actions, intermediate_timestep_count,              &
                intermediate_timestep_count_max, km_constant,                   &
-               les_dynamic, les_mw, ocean, plant_canopy, prandtl_number,       &
-               prho_reference, pt_reference, rans_mode, rans_tke_e, rans_tke_l,&
+               les_dynamic, les_mw, ocean_mode, plant_canopy, prandtl_number,  &
+               pt_reference, rans_mode, rans_tke_e, rans_tke_l,                &
                simulated_time,timestep_scheme, turbulence_closure,             &
                turbulent_inflow, use_upstream_for_tke, vpt_reference,          &
@@ -190,4 +193,7 @@
 
     USE kinds
+
+    USE ocean_mod,                                                             &
+        ONLY:  prho_reference
 
     USE pegrid
@@ -1116,5 +1122,5 @@
                 e  = e_init
              ELSE
-                IF ( .NOT. ocean )  THEN
+                IF ( .NOT. ocean_mode )  THEN
                    kh   = 0.01_wp   ! there must exist an initial diffusion, because 
                    km   = 0.01_wp   ! otherwise no TKE would be produced by the
@@ -1160,5 +1166,5 @@
              e  = e_init
           ELSE
-             IF ( .NOT. ocean )  THEN
+             IF ( .NOT. ocean_mode )  THEN
                 kh   = 0.01_wp   ! there must exist an initial diffusion, because 
                 km   = 0.01_wp   ! otherwise no TKE would be produced by the
@@ -2155,5 +2161,5 @@
 
        IF ( .NOT. humidity )  THEN
-          IF ( ocean )  THEN
+          IF ( ocean_mode )  THEN
              CALL diffusion_e( prho, prho_reference )
           ELSE
@@ -2423,5 +2429,5 @@
 
        IF ( .NOT. humidity )  THEN
-          IF ( ocean )  THEN
+          IF ( ocean_mode )  THEN
              CALL diffusion_e( i, j, prho, prho_reference )
           ELSE
@@ -2934,5 +2940,5 @@
           IF ( .NOT. humidity )  THEN
 
-             IF ( ocean )  THEN
+             IF ( ocean_mode )  THEN
 !
 !--             So far in the ocean no special treatment of density flux
@@ -3738,5 +3744,5 @@
        IF ( .NOT. humidity )  THEN
 
-          IF ( ocean )  THEN
+          IF ( ocean_mode )  THEN
 !
 !--          So far in the ocean no special treatment of density flux in
Index: palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3291)
+++ palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -95,5 +98,8 @@
        USE arrays_3d,                                                          &
            ONLY:  inflow_damping_factor, mean_inflow_profiles, pt_init,        &
-                  q_init, ref_state, s_init, sa_init, u_init, ug, v_init, vg
+                  q_init, ref_state, s_init, u_init, ug, v_init, vg
+
+       USE bulk_cloud_model_mod,                                               &
+           ONLY:  bulk_cloud_model, bcm_wrd_global
 
        USE date_and_time_mod,                                                  &
@@ -112,7 +118,4 @@
            ONLY:  nx, ny, nz
 
-       USE bulk_cloud_model_mod,                                               &
-           ONLY:  bulk_cloud_model, bcm_wrd_global
-
        USE model_1d_mod,                                                       &
            ONLY:  damp_level_1d, dt_pr_1d, dt_run_control_1d, end_time_1d
@@ -120,4 +123,7 @@
        USE netcdf_interface,                                                   &
            ONLY:  netcdf_precision, output_for_t0
+
+       USE ocean_mod,                                                          &
+           ONLY:  ocean_wrd_global
 
        USE particle_attributes,                                                &
@@ -238,7 +244,4 @@
        WRITE ( 14 )  bc_s_t
 
-       CALL wrd_write_string( 'bc_sa_t' ) 
-       WRITE ( 14 )  bc_sa_t
-
        CALL wrd_write_string( 'bc_uv_b' ) 
        WRITE ( 14 )  bc_uv_b
@@ -246,7 +249,4 @@
        CALL wrd_write_string( 'bc_uv_t' ) 
        WRITE ( 14 )  bc_uv_t
-
-       CALL wrd_write_string( 'bottom_salinityflux' ) 
-       WRITE ( 14 )  bottom_salinityflux
 
        CALL wrd_write_string( 'building_height' ) 
@@ -497,6 +497,6 @@
        WRITE ( 14 )  ny
 
-       CALL wrd_write_string( 'ocean' ) 
-       WRITE ( 14 )  ocean
+       CALL wrd_write_string( 'ocean_mode' ) 
+       WRITE ( 14 )  ocean_mode
 
        CALL wrd_write_string( 'old_dt' ) 
@@ -622,16 +622,4 @@
        CALL wrd_write_string( 's_vertical_gradient_level_ind' ) 
        WRITE ( 14 )  s_vertical_gradient_level_ind
-
-       CALL wrd_write_string( 'sa_init' ) 
-       WRITE ( 14 )  sa_init
-
-       CALL wrd_write_string( 'sa_surface' ) 
-       WRITE ( 14 )  sa_surface
-
-       CALL wrd_write_string( 'sa_vertical_gradient' ) 
-       WRITE ( 14 )  sa_vertical_gradient
-
-       CALL wrd_write_string( 'sa_vertical_gradient_level' ) 
-       WRITE ( 14 )  sa_vertical_gradient_level
 
        CALL wrd_write_string( 'scalar_advec' ) 
@@ -738,7 +726,4 @@
        WRITE ( 14 )  top_momentumflux_v
 
-       CALL wrd_write_string( 'top_salinityflux' ) 
-       WRITE ( 14 )  top_salinityflux
-
        CALL wrd_write_string( 'top_scalarflux' ) 
        WRITE ( 14 )  top_scalarflux
@@ -876,7 +861,4 @@
        WRITE ( 14 )  wall_humidityflux
 
-       CALL wrd_write_string( 'wall_salinityflux' ) 
-       WRITE ( 14 )  wall_salinityflux
-
        CALL wrd_write_string( 'wall_scalarflux' ) 
        WRITE ( 14 )  wall_scalarflux
@@ -897,30 +879,16 @@
        WRITE ( 14 )  z_i
 
-
-!    
-!-- The order of the calls can be different as in read_restart_data_mod where
-!-- the restart data will be read 
-
-!
-!-- If required, write restart data for gust module.
-       IF ( bulk_cloud_model )  CALL bcm_wrd_global
-!
-!-- If required, write restart data for wind turbine model.
-       IF ( wind_turbine )  CALL wtm_wrd_global
-
-!
-!-- If required, write restart data for virtual measurements.
-       IF ( virtual_flight )  CALL flight_wrd_global
-
-!
-!-- If required, write restart data for turbulence generator.
-       IF ( syn_turb_gen )  CALL stg_wrd_global
-
-!
-!-- If required, write restart data for gust module.
+!
+!--    Write restart data of the other modules
+!--    The order of the calls can be different as in read_restart_data_mod where
+!--    the restart data will be read
+       IF ( bulk_cloud_model )     CALL bcm_wrd_global
+       IF ( virtual_flight )       CALL flight_wrd_global
        IF ( gust_module_enabled )  CALL gust_wrd_global
-
-!
-!-- Write restart data for user data.
+       IF ( ocean_mode )           CALL ocean_wrd_global
+       IF ( syn_turb_gen )         CALL stg_wrd_global
+       IF ( wind_turbine )         CALL wtm_wrd_global
+!
+!--    Write restart data of the user-interface
        CALL user_wrd_global
 
@@ -940,5 +908,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  e, kh, km, p, pt, q, ql, s, sa, u, u_m_l, u_m_n, u_m_r,      &
+           ONLY:  e, kh, km, p, pt, q, ql, s, u, u_m_l, u_m_n, u_m_r,          &
                   u_m_s, v, v_m_l, v_m_n, v_m_r, v_m_s, vpt, w, w_m_l, w_m_n,  &
                   w_m_r, w_m_s
@@ -960,4 +928,7 @@
        USE land_surface_model_mod,                                             &
            ONLY:  lsm_wrd_local
+
+       USE ocean_mod,                                                          &
+           ONLY:  ocean_wrd_local
 
        USE particle_attributes,                                                &
@@ -1112,21 +1083,4 @@
        ENDIF
        
-       IF ( ocean )  THEN
-
-          IF ( ALLOCATED( rho_ocean_av ) )  THEN
-             CALL wrd_write_string( 'rho_ocean_av' ) 
-             WRITE ( 14 )  rho_ocean_av
-          ENDIF
-
-          CALL wrd_write_string( 'sa' ) 
-          WRITE ( 14 )  sa
-
-          IF ( ALLOCATED( sa_av ) )  THEN
-             CALL wrd_write_string( 'sa_av' ) 
-             WRITE ( 14 )  sa_av
-          ENDIF
-
-       ENDIF
-
        IF ( ALLOCATED( ql_c_av ) )  THEN
           CALL wrd_write_string( 'ql_c_av' ) 
@@ -1310,48 +1264,20 @@
 
 !
-!-- If required, write restart data for microphysics module.
-       IF ( bulk_cloud_model )  THEN
-          CALL bcm_wrd_local
-       ENDIF
-
-!
-!-- Write surface-related restart data.
+!--    Write restart data of other modules
+       IF ( bulk_cloud_model )     CALL bcm_wrd_local
+       IF ( air_chemistry )        CALL chem_wrd_local
+       IF ( gust_module_enabled )  CALL gust_wrd_local
+       IF ( land_surface )         CALL lsm_wrd_local
+       IF ( ocean_mode )           CALL ocean_wrd_local
        CALL surface_wrd_local
-
-!
-!-- If required, write restart data for urban surface model.
-       IF ( urban_surface )  THEN
-          CALL usm_wrd_local
-       ENDIF
-
-!
-!-- If required, write restart data for land surface model.
-       IF ( land_surface )  THEN
-          CALL lsm_wrd_local
-       ENDIF
-
-!
-!-- If required, write restart data for radiation model.
-       IF ( radiation )  THEN
-          CALL radiation_wrd_local
-       ENDIF
-
-!
-!-- If required, write restart data for chemistry model.
-       IF ( air_chemistry )  THEN
-          CALL chem_wrd_local
-       ENDIF
-
-!
-!-- If required, write restart data for gust module.
-       IF ( gust_module_enabled )  THEN
-          CALL gust_wrd_local
-       ENDIF
-
-!
-!-- Write user-related restart data.
+       IF ( radiation )            CALL radiation_wrd_local
+       IF ( urban_surface )        CALL usm_wrd_local
+
+!
+!--    Write user-defined restart data
        CALL user_wrd_local
 
-!--    Write end label.
+!
+!--    Write end label
        CALL wrd_write_string( '*** end ***' )
 
